package com.bonait.bnframework.common.linktab;

import android.content.res.Resources;
import android.graphics.Color;

import androidx.annotation.LayoutRes;
import androidx.annotation.Nullable;
import androidx.recyclerview.widget.RecyclerView;

import com.bonait.bnframework.R;
import com.bonait.bnframework.common.view.MyLayoutManager;
import com.bonait.bnframework.modules.home.adapter.liaochang_adapter;
import com.bonait.bnframework.modules.home.adapter.sx_adapter;
import com.bonait.bnframework.modules.home.adapter.zsx_adapter;
import com.chad.library.adapter.base.BaseQuickAdapter;
import com.chad.library.adapter.base.viewholder.BaseViewHolder;

import java.util.List;

public class RightAdapter extends BaseQuickAdapter<LinkMode, BaseViewHolder> {

    public List<LinkMode> Fdata;
    public Resources resources;
    public RightAdapter(@LayoutRes int layoutResId, @Nullable List<LinkMode> data, Resources _resources) {
        super(layoutResId, data);
        resources=_resources;
        Fdata=data;
    }

    @Override
    protected void convert(BaseViewHolder holder, LinkMode item) {
        RecyclerView view= holder.getView(R.id.recycler_view);

        MyLayoutManager layout = new MyLayoutManager();
        layout.setAutoMeasureEnabled(true);
        view.setLayoutManager(layout);
        liaochang_adapter adapter = new liaochang_adapter(getContext(), item.content);
        view.setAdapter(adapter);

        //holder.setText(R.id.RecyclerView,item.content.get(0));
    }
}